// data/gametests/src/main.ts
import { world } from "@minecraft/server";
world.afterEvents.playerInteractWithBlock.subscribe((event) => {
  const location = event.faceLocation;
  const item = event.itemStack;
  const player = event.player;
  location.y += 1.2;
  if (player.getProperty("vb:backpack_type") === "none" && item.typeId != "vb:backpack_leather" && item.typeId != "vb:backpack_iron" && item.typeId != "vb:backpack_gold" && item.typeId != "vb:backpack_diamond" && item.typeId != "vb:backpack_netherite")
    return;
  else if (!item && player.isSneaking && player.getProperty("vb:backpack_type") !== "none") {
    player.runCommandAsync(`/tp @e[type=vb:backpack,tag=on_shoulder,c=1] ${location.x} ${location.y} ${location.z} facing @a[c=1]`);
  } else if (item.typeId == "vb:backpack_zipper" && player.isSneaking && player.getProperty("vb:backpack_type") !== "none") {
    player.runCommandAsync(`/tp @e[type=vb:backpack,tag=on_shoulder,c=1] ${location.x} ${location.y} ${location.z} facing @a[c=1]`);
  } else if (item.typeId == "vb:backpack_leather" || item.typeId == "vb:backpack_iron" || item.typeId == "vb:backpack_gold" || item.typeId == "vb:backpack_diamond" || item.typeId == "vb:backpack_netherite") {
    player.onScreenDisplay.setActionBar({
      rawtext: [
        { translate: "action.hint.backpack.spawn" }
      ]
    });
  }
});
world.afterEvents.playerInteractWithEntity.subscribe((event) => {
  const player = event.player;
  const playerName = event.player.name;
  const target = event.target;
  const location = event.player.location;
  if (target.typeId == "vb:backpack_inventory" && !target.getProperty("vb:on_shoulder") && player.isSneaking && player.getProperty("vb:backpack_type") === "none" && !player.getProperty("vb:has_rider")) {
    player.triggerEvent("vb:set_backpack_on_shoulder");
    player.onScreenDisplay.setActionBar({
      rawtext: [
        { translate: "action.hint.backpack.unequip" }
      ]
    });
  } else if (target.typeId == "vb:backpack_inventory" && !target.getProperty("vb:on_shoulder") && player.isSneaking && player.getProperty("vb:backpack_type") !== "none") {
    player.onScreenDisplay.setActionBar({
      rawtext: [
        { translate: "action.hint.backpack.with_other_backpack" }
      ]
    });
    player.runCommand("/playsound note.bassattack @s ~~~ 0.4 0.7");
  } else if (target.typeId == "vb:backpack_inventory" && !target.getProperty("vb:on_shoulder") && player.isSneaking && player.getProperty("vb:backpack_type") === "none" && player.getProperty("vb:has_rider")) {
    player.onScreenDisplay.setActionBar({
      rawtext: [
        { translate: "action.hint.backpack.with_rider" }
      ]
    });
    player.runCommand("/playsound note.bassattack @s ~~~ 0.4 0.7");
  } else if (target.typeId == "vb:backpack_inventory" && !target.getProperty("vb:on_shoulder") && !player.isSneaking) {
    player.runCommand(`/execute positioned ~ ~ ~ run playsound armor.equip_leather @a ${location.x} ${location.y} ${location.z}`);
    target.runCommand("/playanimation @e[c=1,type=vb:backpack] animation.backpack.open");
  } else if (target.typeId == "vb:backpack_inventory" && target.getProperty("vb:on_shoulder") && !player.isSneaking) {
    player.runCommand(`/execute positioned ~ ~ ~ run playsound armor.equip_leather @a ${location.x} ${location.y} ${location.z}`);
  }
});
world.afterEvents.entityDie.subscribe((event) => {
  const entity = event.deadEntity;
  const location = event.deadEntity.location;
  if (entity.typeId != "minecraft:player")
    return;
  if (entity.typeId == "minecraft:player") {
    entity.runCommandAsync("/tp @e[type=vb:backpack,c=1] ~ ~1 ~");
  }
});
